#ifndef __CONFIG_H_
#define __CONFIG_H_

#if !defined(__C251__) && !defined(__C51__)
#include "../debug.h"
#endif

// ٷͷļ
#include "STC32F.h"

// Cִ֧
#include "intrins.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define PI 3.14159265358979323846
#define _2PI 6.28318530718f
#define _3PI 9.42477796077f
// ܶ
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long


#define All_Can_ID 0  // Ϊ㲥ַڣ޸
#define User_Can_ID 3

// ģʽ
#define Speed_Mode 1    // ٶģʽ
#define Postion_Mode 2  // λģʽ
#define OpenLoop_Mode 3 // ģʽ
#define Set_ID_Mode 4   // IDģʽأ
#define Servo_Mode 5    // ģʽ
// ģʽл
#define Default_Mode Speed_Mode

#define voltage_power_supply 8.0f

#define DEBUG_LED P54

#define KEY1 P13

#define CSN P26 // űʹ

#define MU P20
#define MUN P21
#define MV P22
#define MVN P23
#define MW P24
#define MWN P25

#define MAIN_Fosc 52000000UL // ʱ
#define Baudrate (65536UL - (MAIN_Fosc / 4) / 115200UL)

extern char _dir; // 
extern u8 _pp;    // 
extern u16 _zero; // ƫֵ

extern float postion_add;     // Сڷֱʱʱۼ
extern long last_postion_add; // ϴ
extern bit Run_Flag;
extern bit Dir_Flag;
extern u8 Mode;

extern bit Auto_Look_Moto_Config_Flag; // д1һԶʶ
extern long Can_Value;
extern bit Servo_Config_Flag;            // Զ̽λ־д1
extern long Servo_This_Pos;              // ʼֵ
extern int Servo_Add_Pos;                // 
extern int Servo_Max_Pos, Servo_Min_Pos; // Զò

#define DIR 1 // ʵʱ
#define PP 7  // ʵʵ

// ֵ
#define Encode_bit_Max 16384

#define _constrain(amt, low, high) ((amt) < (low) ? (low) : ((amt) > (high) ? (high) : (amt)))

u32 Micros(void);      // ȡϵͳus
void ICacheOff(void);  // رcacheٻ
void ICacheOn(void);   // cacheٻ
void Delay200ms(void); // ѭʱ

extern u32 Tick_ms; // ȫmsʱ

extern volatile float Duty_A, Duty_B, Duty_C;

// ͨ˲Ҫȫֱ
typedef struct LowPassConfig
{
    volatile unsigned long int last_time; // ϴʱ
    float last_result;                    // ϴν
} LowPassConfig;

// ȫֱ
typedef struct Moto_Config
{
    float set_uq;     // 趨iqֵ
    float uq;         // q,и
    u16 angle_dat;    // űԭʼ
    int set_speed;    // 趨ٶ
    int speed;        // ǰʵٶ,ٶȻи
    long set_postion; // 趨λ
    long postion;     // ǰʵλãλûи
} Moto_Config;

typedef struct Moto_Save_Dat
{
    char dir;       // 
    u8 pp;        // 
    u16 zero;     // У׼ֵ
    u8 can_id;    // canͨѶõַ
    u8 save_ok;   // Ƿ񱣴
    u8 buffer[6]; // д/
} Moto_Save_Dat;

extern Moto_Config moto;        // 
extern Moto_Save_Dat moto_save; // 

#if (MAIN_Fosc < 30000000UL)
#define WAIT 0x00
#elif (MAIN_Fosc < 60000000UL)
#define WAIT 0x01
#else
#define WAIT 0x02
#endif

// Զ׷Ƶ
// IRCBANDIRCƵѡ񣩼Ĵֵ
#if (MAIN_Fosc > 35000000UL)
#define BAND 0x02
#elif (MAIN_Fosc > 20000000UL)
#define BAND 0x01
#else
#define BAND 0x00
#endif
#define BAND_MASK 0x03

// CLKDIVĴֵϵͳʱƵ
#if (MAIN_Fosc > 15000000UL)
#define DIV 0x01
#elif (MAIN_Fosc > 12000000UL)
#define DIV 0x02
#elif (MAIN_Fosc > 8000000UL)
#define DIV 0x03
#elif (MAIN_Fosc > 6000000UL)
#define DIV 0x04
#else
#define DIV 0x05
#endif

// ׷ƵĴĿֵ
#define MCLK (MAIN_Fosc * DIV)

#if (MCLK < 50000000UL)
#define CNT ((16 * MCLK) / 32768) // Ƶ
#define CREHF 0x00
#else
#define CNT ((8 * MCLK) / 32768) // Ƶ
#define CREHF 0x08
#endif

#define XRES (CNT * 5 / 1000)

#endif
