#ifndef __CONFIG_H_
#define __CONFIG_H_

#if !defined(__C251__) && !defined(__C51__)
#include "../debug.h"
#endif

// ٷͷļ
#include "STC32F.h"

// Cִ֧
#include "intrins.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define PI 3.14159265358979323846
#define _2PI 6.28318530718f
#define _3PI 9.42477796077f
// ܶ
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long

// ģʽ
#define Speed_Mode 2	// ٶģʽ
#define Postion_Mode 3	// λģʽ
#define OpenLoop_Mode 4 // ģʽ
// ģʽл
#define Default_Mode Speed_Mode

#define DEBUG_LED P52

#define KEY1 P34

#define CSN P40 // űʹ

#define MU P20
#define MUN P21
#define MV P22
#define MVN P23
#define MW P24
#define MWN P25

#define MAIN_Fosc 52000000UL // ʱ
#define Baudrate (65536UL - (MAIN_Fosc / 4) / 115200UL)

extern char _dir;   // 
extern u8 _pp;    // 
extern u16 _zero; // ƫֵ

extern bit Run_Flag;
extern bit Dir_Flag;
extern u8 Mode;


#define DIR 1 // ʵʱ
#define PP 7  // ʵʵ

// ֵ
#define Encode_bit_Max 16384

#define voltage_power_supply 8.0 // ߵѹ
#define _constrain(amt, low, high) ((amt) < (low) ? (low) : ((amt) > (high) ? (high) : (amt)))

u32 Micros(void);     // ȡϵͳus
void ICacheOff(void); // رcacheٻ
void ICacheOn(void);  // cacheٻ

extern u32 Tick_ms; // ȫmsʱ

extern volatile float Duty_A, Duty_B, Duty_C;

// ͨ˲Ҫȫֱ
typedef struct LowPassConfig
{
    volatile unsigned long int last_time; // ϴʱ
    float last_result;                    // ϴν
} LowPassConfig;

// PIDҪȫֱ
typedef struct PID_Register
{
    volatile unsigned long int timestamp_prev; // ϴʱ
    float P;                                   // Kp
    float I;                                   // Ki
    float D;                                   // Kd
		float I_limit;														 //޷
    float output_ramp;                         // ٶ޷
    float limit;                               // ޷
    float error_prev;                          // ϴ
    float output_prev;                         // ϴ
    float integral_prev;                       // ϴλּ
} PID_Register;

// ȫֱ
typedef struct Moto_Config
{
    float set_uq;     // 趨iqֵ
    float uq;         // q,и
    u16 angle_dat;    // űԭʼ
    int set_speed;    // 趨ٶ
    int speed;        // ǰʵٶ,ٶȻи
    long set_postion; // 趨λ
    long postion;     // ǰʵλãλûи
} Moto_Config;

#endif
