#include "./H_Group/eeprom.h"

void EEPROM_Init(u8 CMD_Dat, u32 addr)
{
    P_SW2 |= 0x80;                         // ʹܷXFR
    IAP_CONTR = 0x80;                      // IAP
    IAP_TPS = (u8)(MAIN_Fosc / 1000000UL); // ϵͳƵ,Զ㴦
    IAP_CMD = CMD_Dat;                     // ָ
    IAP_ADDRL = addr;                      // ֵַ
    IAP_ADDRH = addr >> 8;
    IAP_ADDRE = addr >> 16;
}

// رIAP
void Iap_Idle(void)
{
    IAP_CONTR = 0x00;
    IAP_CMD = 0x00;
    IAP_TRIG = 0x00;
    IAP_ADDRE = 0x00;
    IAP_ADDRH = 0x00;
    IAP_ADDRL = 0x00;
}

// IAPָ,0.5
void Iap_Erase(u32 addr)
{
    ICacheOff();          // ʱصiCache
    EEPROM_Init(6, addr); // ָ
    IAP_TRIG = 0x5a;
    IAP_TRIG = 0xa5; // 
    NOP4();          // ĸָ
    Iap_Idle();      // رIAP
    ICacheOn();      // »ָiCache
}

// IAPдָֽд
void Iap_Write(u32 addr, char dat)
{
    ICacheOff();          // ʱصiCache
    EEPROM_Init(2, addr); // дָ
    IAP_DATA = dat;
    IAP_TRIG = 0x5a; // 
    IAP_TRIG = 0xa5;
    NOP4();
    Iap_Idle(); // رIAP
    ICacheOn(); // »ָiCache
}

// IAPָֽڶ
char Iap_Read(u32 addr)
{
    char dat = 0;
    ICacheOff(); // ʱصiCache
    EEPROM_Init(1, addr);
    IAP_TRIG = 0x5a; // 
    IAP_TRIG = 0xa5;
    NOP4();
    dat = IAP_DATA;
    Iap_Idle();
    ICacheOn(); // »ָiCache
    return dat;
}

#define IAP_OFFSET 0xD5FF // STC32F12K54-Ĭ0.5KEEPROMռ

char Read_Flash_Data(int addr)
{
    addr += IAP_OFFSET;
    return *(int code *)(addr);
}

void Set_Setting_Data(u8 dir, u8 pp, u16 zero)
{
    ICacheOff();  // ʱصiCache
    Iap_Erase(0); // һ
    Iap_Write(Flash_DIR, dir); // 
    Iap_Write(Flash_PP, pp); // 
    Iap_Write(Flash_ZeroH, (u8)(zero >> 8)); // Ƕλã߰λ
    Iap_Write(Flash_ZeroL, (u8)zero);
    Iap_Write(Flash_OK, 0x01); // ־Ѿ
    ICacheOn(); // »ָiCache
}

void Set_I2c_Addr(u8 i2c_addr)
{
    ICacheOff();  // ʱصiCache
    Iap_Write(Flash_Addr, i2c_addr); // ͨѶ
    ICacheOn(); // »ָiCache
}